﻿using HeartTrack.Models;
using static MudBlazor.CategoryTypes;

namespace HeartTrack.Factories
{
    public static class TicketFactory
    { 
        public static TicketModel ToModel(Ticket item)
        {
            return new TicketModel
            {
                Id = item.Id,
                Username = item.Username,
                Contexte = item.Contexte,
                Description = item.Description,
                Urgence = Convert.ToBoolean(item.Urgence)
            };
        }

        public static Ticket Create(TicketModel model)
        {
            return new Ticket
            {
                Id = model.Id,
                Username = model.Username,
                Contexte = model.Contexte,
                Description = model.Description,
                Urgence = Convert.ToString(model.Urgence)
            };
        }
    }
}
